<?php /* BISMILLAHIRRAHMANIRRAHEEM */

//-- Configurations:
$filehouseslist = "houseslist.txt";
$fdelimiter = "*|*";
$filehouseprefix = "house";	// For example: $filehouseprefix . $filehousesuffix is "house.txt" or "house"[HID]".txt"
$filehousesuffix = ".txt";		// Script generates file names for houses "house1.txt", "house2.txt" etc
header('Content-Type: application/json; charset=utf-8');
$housepatidseparator = " "; // "00100{$housepatidseparator}Last_Name, First_Name, dd.mm.yyyy"  // "00100  Last_Name, First_Name, dd.mm.yyyy"
$pathworkstation = "textdata"; // "/var/samba/trp"
$fileworkstation = "pat-archiv.txt";

$workstations = [	"C" => "C",	
							"D" => "D",
							"E" => "E",
							"B" => "B"	];

$jdata = json_decode(file_get_contents('php://input'), true); // JSON data, parse into $jdata array, can check by print_r($jdata) INSHAALLAH

$jdata["Action"] == "UpdatePatientsListStandalone";
//$ret["status"] = ""; // status, true on success, false on failure/ error
$ret["Action"] = $jdata["Action"]; // returns the Action/ Action code, same as request
//$ret["data"] = ""; // contains payload/ return data
//$ret["message"] = ""; // contains error message, if any
$ret["message"] = "";

/*
Pass input data in JSON format
>> php.exe houselist_insert.php {JSON}
>> php.exe houselist_insert.php {house:house name ABC, arch_exp:/var/samba/trf/C/pat-arch.txt, wsid:C}

output is JSON too
Input variables:
{
	house: House name,
	arch_exp: /path/to/external/txt/file
	wsid: workstation ID
}
Output JSON:
{
	Action: UpdatePatientsListStandalone,
	status: true, // (or false)
	message: "success", // (or failure)
}


*/

if ($jdata["Action"] == "UpdatePatientsListStandalone") {
	try {
		/*
			$f					file (handle)
			$fcontents		file contents
			$fline			file line (current line being read)
			$flcount			file line count (file contents line count)
		*/
		$jdata["HID"] = 0;
		$HID = 0;
		$HouseName = trim($jdata["house"]); // input variables
		$fileworkstation = $jdata["arch_exp"]; // input variables
		if ((!array_key_exists("wsid", $jdata)) || ($jdata["wsid"] == "")) {
			echo "Error: wsid not set, eg. box.php?wsid=t0";
			die;
		}
		$wsid = trim($jdata['wsid']);
		
		$filename = $filehouseslist;
		//$file = join(DIRECTORY_SEPARATOR, array('textdata', $filename));
		$file = join(DIRECTORY_SEPARATOR, array('textdata', $filename));
		$f = fopen($file, "r");// or die("Unable to open file: " . $file . "<br />Please check directory/ file permissions");
		if (!$f) {
			throw new Exception("Could not open house file: " . basename($file) . "<br />Please check directory/ file permissions");
		}
		$houseslist = [];
		$house = null;
		$house["HID"] = 0;
		$house["House"] = "";
		$house["Patients"] = "";
		$HID = 0;
		$i = 0;
		if (filesize($file) > 0) {
			rewind($f);
			while ($fline = fgets($f)) {
				$fline = trim($fline);
				if ($fline != "") {
					$h = explode($fdelimiter, $fline);
					if ((count($h) == 2) && (intval($h[0]) > 0)) { // HID must be greater than 0
						if (trim(strtolower($h[1])) == strtolower($HouseName)) {
							$HID = trim($h[0]);
							$house["HID"] = $HID;
							$house["House"] = trim($h[1]);
							$houseslist[$i]["HID"] = $h[0];
							$houseslist[$i]["House"] = $h[1];
						}
						$i = $i + 1;
					}/*else {
						throw new Exception("Incorrect house list data format. File: " . basename($file) . " is not in correct format. Correct format:<br />ID (int)" . $fdelimiter . "House name (string)");
					}*/
				}
			}
		}
		fclose($f); // ALHAMDOLILLAH houses list loaded

		///////////////////////////////// Read samba workstation file
		$wpatient = [0, "", "", "", ""]; // workstation patient
		$filename = $fileworkstation;

		$file = join(DIRECTORY_SEPARATOR, array($pathworkstation, $workstations[$wsid], $filename));
		if (file_exists($file)) {
			$f = fopen($file, "r");
			/*if (!$f) {
				throw new Exception("Could not open patients file: " . basename($file) . "<br />Please check directory/ file permissions");
			}*/
			$fs = filesize($file);
			if ($fs > 0) {
				rewind($f); // just in case
				//$patientslist = fread($f, $fs);
				$i = 0;
				//while ($fline = fgets($f)) $fline = trim($fline);
				while ($fline = fgets($f)) {
					$fline = trim($fline);
					if ($i < 5) {
						if ($fline != "") {
							$wpatient[$i] = $fline;
							$i = $i + 1;
						}
					} else {
						throw new Exception("Incorrect Workstation Patient file format: " . $file . " Must be 5 lines atleast");
					}
				}
			}
			fclose($f);
		}
		$pfound = false; // patient found
		$wtmpd = substr($wpatient[4], 0, 2);
		$wtmpm = substr($wpatient[4], 2, 2);
		$wtmpy = substr($wpatient[4], 4, 4);
		$wpatient[4] = $wtmpd . "." . $wtmpm . "." . $wtmpy;
		$wpdata = intval($wpatient[0]) . $housepatidseparator . $wpatient[1] . ", " . $wpatient[2] . ", " . $wpatient[4]; // Gender . $wpatient[3];
		if ($house["HID"] > 0) {
			$filename = $filehouseprefix . $house["HID"] . $filehousesuffix;
			$file = join(DIRECTORY_SEPARATOR, array('textdata', $filename));
			if (file_exists($file)) {
				$f = fopen($file, "a+");
				if (!$f) {
					throw new Exception("Could not open patients file: " . basename($file) . "<br />Please check directory/ file permissions");
				}
				$fs = filesize($file);
				if ($fs > 0) {
					rewind($f); // just in case
					//$patientslist = fread($f, $fs);
					$i = 0;
					while ($fline = fgets($f)) {
						$fline = trim($fline);
						if ($fline != "") {
							$pat = explode(" ", $fline);
							if (intval($pat[0]) == intval($wpatient[0])) { // patient id matched
								if ($pfound == false) {
									$pfound = true;
									$patientslist[$i] = $wpdata;
									if ($house["Patients"] == "") {
										$house["Patients"] = $patientslist[$i];
									} else {
										$house["Patients"] = $house["Patients"] . "
" . $patientslist[$i];
									}
								} //else { // repeated entry, ignore
							} else { // patient id did not match
								$patientslist[$i] = $fline;
								if ($house["Patients"] == "") {
									$house["Patients"] = $patientslist[$i];
								} else {
									$house["Patients"] = $house["Patients"] . "
" . $patientslist[$i];
								}
							}
							$i = $i + 1;
						}
					}
					if (($pfound == false) && ($wpatient[0] > 0)) {
						$patientslist[$i] = $wpdata;
						if ($house["Patients"] == "") {
							$house["Patients"] = $patientslist[$i];
						} else {
							$house["Patients"] = $house["Patients"] . "
" . $patientslist[$i];
						}
					}
					fclose($f);
					// Update house patients file
					$f = fopen($file, "w");
					if (!$f) {
						throw new Exception("Could not open patients file: " . basename($file) . "<br />Please check directory/ file permissions.");
					}
					foreach($patientslist as $p) {
						fputs($f, trim($p) . "\r\n");
					}
					fclose($f);
				}
			}
			$ret["status"] = true;
			$ret["message"] = "ALHAMDOLILLAH patients list updated successfully.";
		} else {
			$ret["status"] = false;
			$ret["message"] = "Invalid House Name. House ID not found.";
		}
		$ret["data"] = $house;
	}
	catch (Exception $e) {
		$ret["status"] = false;
		$ret["message"] = "PHP Exception:<br />
		<div class=\"table\">
			<div class=\"rowsimple\">
				<div class=\"colerrorcategory\">File:</div>
				<div class=\"colerrordetails\">" . basename($e->getFile()) . "</div>
			</div>
			<div class=\"rowsimple\">
				<div class=\"colerrorcategory\">Line:</div>
				<div class=\"colerrordetails\">" . $e->getLine() . "</div>
			</div>
			<div class=\"rowsimple\">
				<div class=\"colerrorcategory\">Message:</div>
				<div class=\"colerrordetails\">" . $e->getMessage() . "</div>
			</div>
		</div>";
	}
	
}











//echo json_encode(utf8ize($ret), JSON_FORCE_OBJECT); // Doesn't encode non-English characters without UTF-8
echo json_encode($ret, JSON_FORCE_OBJECT); // Doesn't encode non-English characters without UTF-8

// https://stackoverflow.com/questions/19361282/why-would-json-encode-return-an-empty-string
function utf8ize($d) {
	if (is_array($d)) {
		foreach ($d as $k => $v) {
			$d[$k] = utf8ize($v);
		}
	} else if (is_string ($d)) {
		return utf8_encode($d);
	}
	return $d;
}

function deutf8ize($d) {
	if (is_array($d)) {
		foreach ($d as $k => $v) {
			$d[$k] = utf8ize($v);
		}
	} else if (is_string ($d)) {
		return utf8_decode($d);
	}
	return $d;
}

?>
